// Entities that are used by bots for their 'pathfinding'
globalvar MOBAentity, MOBAspawn, MOBAmoveBox, MOBAwall, MOBAwall2;
MOBAentity = object_add();
object_set_mask(MOBAentity, MOBAentityS);
object_event_add(MOBAentity, ev_create, 0, '
    lastChanged = 0;
    type = 0;
');
object_event_add(MOBAentity, ev_draw, 0, '
    if (!MOBA.debug || distance_to_point(view_xview + view_wview/2, view_yview + view_hview/2) > 800) exit;
    if (type < 24) draw_sprite(MOBAentityS, type, x, y);
'); 

MOBAspawn = object_add();
object_set_mask(MOBAspawn, MOBAentityS);
object_event_add(MOBAspawn, ev_create, 0, '
    super = false;
    creep = noone;
    type = 0;
'); 
object_event_add(MOBAspawn, ev_draw, 0, '
    if (!MOBA.debug || distance_to_point(view_xview + view_wview/2, view_yview + view_hview/2) > 800) exit;
    if (type < 24) draw_sprite(MOBAentityS, type, x, y);
'); 

MOBAmoveBox = object_add();
object_set_mask(MOBAmoveBox, sprite64);
object_event_add(MOBAmoveBox, ev_create, 0, 'dir = 0;');
object_event_add(MOBAmoveBox, ev_draw, 0, '
    if (!MOBA.debug || distance_to_point(view_xview + view_wview/2, view_yview + view_hview/2) > 800) exit;
    draw_sprite(sprite64, 0, x, y);
'); 

MOBAwall = object_add();
object_event_add(MOBAwall, ev_create, 0, 'sprite_index=sprite45');
object_event_add(MOBAwall, ev_draw, 0, '
    if (!MOBA.debug || distance_to_point(view_xview + view_wview/2, view_yview + view_hview/2) > 800) exit;
    draw_sprite(sprite_index, 0, x, y);
'); 
MOBAwall2 = object_add();
object_set_parent(MOBAwall2, MOBAwall);
object_event_add(MOBAwall2, ev_create, 0, 'sprite_index=sprite44');
object_event_add(RoomChangeObserver, ev_other, ev_room_start, '
    with(Player) for(i=0; i<8; i+=1) GNupgrades[i] = false;

    // initiate MOBA mode
    if (instance_exists(Generator)) {        
        // Read custom moba entities
        var leveldata, tempfile;
        tempfile = temp_directory+"\custommap_walkmask.png";
        leveldata = GG2DLL_extract_PNG_leveldata("Maps/" + global.currentMap + ".png", tempfile);
        
        if(leveldata == "") break;
        
        // handle the leveldata  
        var entityString, walkmaskString, walkmaskSurface, currentPos, entityType, entityX, entityY, wordLength, DIVREPLACEMENT;
        var a, b, entity;
        var ENTITYTAG, ENDENTITYTAG, DIVIDER;
        ENTITYTAG = "{ENTITIES}";
        ENDENTITYTAG = "{END ENTITIES}";
        DIVIDER = chr(10);
        DIVREPLACEMENT = " ";
        
        // grab the entity data
        a = string_pos(ENTITYTAG, leveldata);
        b = string_pos(ENDENTITYTAG, leveldata);
        if(a == 0 || b == 0) break;
        entityString = string_copy(leveldata, a + string_length(ENTITYTAG) + string_length(DIVIDER), b - a - string_length(ENTITYTAG) - string_length(DIVIDER) - 1) + DIVIDER;
        
        currentPos = 1;
        
        while(string_pos(DIVIDER, entityString) != 0) { // continue until there are no more entities left
            // grab the entity type
            wordLength = string_pos(DIVIDER, entityString) - currentPos;
            entityType = string_copy(entityString, currentPos, wordLength);
            entityString = string_replace(entityString, DIVIDER, DIVREPLACEMENT);
            currentPos += wordLength + string_length(DIVREPLACEMENT);
            // grab the x coordinate
            wordLength = string_pos(DIVIDER, entityString) - currentPos;
            entityX = real(string_copy(entityString, currentPos, wordLength));
            entityString = string_replace(entityString, DIVIDER, DIVREPLACEMENT);
            currentPos += wordLength + string_length(DIVREPLACEMENT);
            // grab the y coordinate
            wordLength = string_pos(DIVIDER, entityString) - currentPos;
            entityY = real(string_copy(entityString, currentPos, wordLength));
            entityString = string_replace(entityString, DIVIDER, DIVREPLACEMENT);
            currentPos += wordLength + string_length(DIVREPLACEMENT);
            
            entity = instance_create(entityX, entityY, MOBAentity);
            
            switch(entityType) {
                case "MOBAspawnRed":
                    with(entity) instance_destroy();
                    entity = instance_create(entityX, entityY, MOBAspawn);
                    entity.type = 0;
                break;
                case "MOBAspawnRedSuper":
                    with(entity) instance_destroy();
                    entity = instance_create(entityX, entityY, MOBAspawn);
                    entity.super = true;
                    entity.type = 1;
                break;
                case "MOBAspawnBlue":
                    with(entity) instance_destroy();
                    entity = instance_create(entityX, entityY, MOBAspawn);
                    entity.type = 2;
                break;
                case "MOBAspawnBlueSuper":
                    with(entity) instance_destroy();
                    entity = instance_create(entityX, entityY, MOBAspawn);
                    entity.super = true;
                    entity.type = 3;
                break;
                case "MOBAspawnNeutral":
                    with(entity) instance_destroy();
                    entity = instance_create(entityX, entityY, MOBAspawn);
                    entity.type = 4;
                break;
                case "MOBAspawnNeutralSuper":
                    with(entity) instance_destroy();
                    entity = instance_create(entityX, entityY, MOBAspawn);
                    entity.super = true;
                    entity.type = 5;
                break;
                case "MOBAjumpRightRed": entity.type = 6; break;
                case "MOBAjumpLeftRed": entity.type = 7; break;
                case "MOBAjumpRightBlue": entity.type = 8; break;
                case "MOBAjumpLeftBlue": entity.type = 9; break;
                case "MOBAjumpRightNeutral": entity.type = 10; break;
                case "MOBAjumpLeftNeutral": entity.type = 11; break;
                case "MOBArightRed": entity.type = 12; break;
                case "MOBAleftRed": entity.type = 13; break;
                case "MOBArightBlue": entity.type = 14; break;
                case "MOBAleftBlue": entity.type = 15; break;
                case "MOBArightNeutral": entity.type = 16; break;
                case "MOBAleftNeutral": entity.type = 17; break;
                case "MOBAsplitRed": entity.type = 18; break;
                case "MOBAcombineRed": entity.type = 19; break;
                case "MOBAsplitBlue": entity.type = 20; break;
                case "MOBAcombineBlue": entity.type = 21; break;
                case "MOBAsplitNeutral": entity.type = 22; break;
                case "MOBAcombineNeutral": entity.type = 23; break;
                case "MOBAmoveBoxUp":
                    with(entity) instance_destroy();
                    entity = instance_create(entityX, entityY, MOBAmoveBox);
                    entity.dir = 90;
                break;
                case "MOBAmoveBoxDown":                     
                    with(entity) instance_destroy();
                    entity = instance_create(entityX, entityY, MOBAmoveBox);
                    entity.dir = 270;
                break;
                case "MOBAmoveBoxLeft":
                    with(entity) instance_destroy();
                    entity = instance_create(entityX, entityY, MOBAmoveBox);
                    entity.dir = 180;
                break;
                case "MOBAmoveBoxRight":
                    with(entity) instance_destroy();
                    entity = instance_create(entityX, entityY, MOBAmoveBox);
                    entity.dir = 0;
                break;
                case "MOBAbotWall":
                    with(entity) instance_destroy();
                    entity = instance_create(entityX, entityY, MOBAwall);
                break;
                case "MOBAbotWall_horizontal":
                    with(entity) instance_destroy();
                    entity = instance_create(entityX, entityY, MOBAwall2);
                break;
                case "MOBAturretRed": 
                    with(entity) instance_destroy();
                    entity = instance_create(entityX, entityY, MOBAturret);
                    entity.team = TEAM_RED;
                break;
                case "MOBAturretBlue":
                    with(entity) instance_destroy();
                    entity = instance_create(entityX, entityY, MOBAturret);
                    entity.team = TEAM_BLUE;
                    entity.image_xscale = -1;
                break;
                
                default: with(entity) instance_destroy(); break;
            }
        }
        if (instance_exists(MOBAentity) || instance_exists(SpawnPointRed1)) instance_create(0, 0, MOBAcontroller);
    }
');

globalvar MOBAcontroller;
MOBAcontroller = object_add();
object_event_add(MOBAcontroller, ev_create, 0,'
    first = true;
    respawnTime = 10 * 30 / global.delta_factor;
    toggle = false;
    if (global.isHost) alarm[0] = 10 * 30 / global.delta_factor;
    event_user(1);
    frame = 0;
    
    with(NoticeO) instance_destroy();
    instance_create(0,0,NoticeO);
    NoticeO.notice = NOTICE_CUSTOM;
    NoticeO.message = "Bots will spawn in 10 seconds";
    
    redSuperQueue = 0;
    blueSuperQueue = 0;
'); 

object_event_add(MOBAcontroller, ev_step, ev_step_begin,'
    if(global.run_virtual_ticks) {
        frame += 1; 
        
        if (global.isHost) {
            // Every ~20 seconds
            if ((frame mod 588) == 0) {
                buffer = buffer_create();
                write_ubyte(buffer, 4);
                write_ubyte(buffer, 2);
                PluginPacketSend(global.GNPacketID, buffer);
                buffer_destroy(buffer);
                type = 2;
                event_user(0);
            }            
            // Sync bots
            if ((frame mod MOBA.syncTime) == 0) {
                if (alarm[0] <= 0) {
                    //Tell the clients to spawn bots too
                    var buffer;
                    buffer = buffer_create();
                    write_ubyte(buffer, 4);
                    write_ubyte(buffer, 0);
                    PluginPacketSend(global.GNPacketID, buffer);
                    buffer_destroy(buffer);
                
                    alarm[0] = respawnTime;
                    type = 0;
                    event_user(0);
                    
                    if (redSuperQueue > 0 || blueSuperQueue > 0) {
                        buffer = buffer_create();
                        write_ubyte(buffer, 4);
                        write_ubyte(buffer, 1);
                        PluginPacketSend(global.GNPacketID, buffer);
                        buffer_destroy(buffer);
                        type = 1;
                        event_user(0);
                    }
                }
            
                global.MOBAbuffer = buffer_create();
                write_ubyte(global.MOBAbuffer, 3);
                write_ubyte(global.MOBAbuffer, instance_number(MOBAbot));
                MOBA.sync = true;
                with(MOBAbot) event_user(12);
                with(MOBAturret) event_user(12);
                MOBA.sync = false;
                PluginPacketSend(global.GNPacketID, global.MOBAbuffer);
                buffer_destroy(global.MOBAbuffer);        
            }
        }
    }
    // Run bot AI here to reduce lag
    gunSetSolids();
    with(TeamGate) solid = false;
    with(MOBAwall) solid = true;
    with(BulletWall) solid = false;
    var targetQueue, testDist, playercheck, jumpNow, corrected;
    jumpNow = false;
    
    with(MOBAbot) {
        if (global.run_virtual_ticks) {
            if (!humiliated && alarm[9] <= -1) {
                if (!super && team != 2) {
                    // See if we can attack
                    if (state == 0) {
                        with(Character) {
                            if (player.team != other.team && !cloak) {
                                if (point_distance(x, y, other.x, other.y) < 36) {
                                    other.image_index = 0;
                                    other.state = 1;
                                    other.alarm[6] = 14 / global.delta_factor;
                                    other.oldDir = other.dir;
                                    if (sign(x-other.x)) other.dir = 1;
                                    else other.dir = -1;
                                    break;
                                }
                            }
                        }
                    }
                    if (state == 0) {
                        with(Generator) {
                            if (team != other.team) {
                                if (point_distance(x, y, other.x, other.y) < 36) {
                                    other.animIndex = 0;
                                    other.state = 1;
                                    other.alarm[6] = 14 / global.delta_factor; 
                                    other.oldDir = other.dir;
                                    if (sign(x-other.x)) other.dir = 1;
                                    else other.dir = -1;

                                    if (object_index == MOBAbot) {
                                        if (state == 0) {
                                            animIndex = 0;
                                            state = 1;
                                            alarm[6] = 14 / global.delta_factor; 
                                            oldDir = dir;
                                            if (sign(other.x-x)) dir = 1;
                                            else dir = -1;
                                        }
                                    }
                                    break;
                                }
                            }
                        }
                    }
                } else if (super == 1 && (other.frame mod 10) == 0) {                      
                    nearestTarget = noone;
                    targetQueue = ds_priority_create();
                    
                    // Build a queue of potential targets
                    with(Character) {
                        testDist = distance_to_object(other);
                        if(!cloak && testDist<=100 && player.team != other.team) {
                            ds_priority_add(targetQueue, id, testDist);
                        }
                    }
                    
                    with(Sentry) {
                        testDist = distance_to_object(other);
                        if(testDist<=90 && team != other.team && hp > 0) {
                            ds_priority_add(targetQueue, id, testDist);
                        }
                    }
                    
                    with(Generator) {
                        testDist = distance_to_object(other);
                        if(testDist<=90 && team != other.team) {
                            ds_priority_add(targetQueue, id, testDist+100);
                        }
                    }
                    
                    while(!nearestTarget && !ds_priority_empty(targetQueue)) {
                        playercheck = ds_priority_delete_min(targetQueue);
                        if(collision_line(x,y,playercheck.x,playercheck.y,Obstacle,true,true)<0
                            && collision_line(x,y,playercheck.x,playercheck.y,IntelGate,true,true)<0
                            && collision_line(x,y,playercheck.x,playercheck.y,BulletWall,true,true)<0) {
                            nearestTarget = playercheck;
                        }
                    }
                
                    ds_priority_destroy(targetQueue);
                    
                    if (instance_exists(nearestTarget)) {
                        with(Spy) {
                            if(team != other.team && collision_line(other.x,other.y,other.nearestTarget.x,other.nearestTarget.y,id,true,false)>=0) {
                                other.nearestTarget = id;
                            }
                        }
                        if (!canAirblast && alarm[4] < 0) alarm[4] = airblastTime / 5 / global.delta_factor;

                        aimDirection = point_direction(x,y,nearestTarget.x,nearestTarget.y);
                        
                        // Give superdroids a phlogistinator because that lags less :)
                        if (point_distance(x, y, nearestTarget.x, nearestTarget.y) < 26 && canAirblast) {
                            // Get out of my face!
                            playsound(x,y,CompressionBlastSnd);
                            poof = instance_create(x+lengthdir_x(25,aimDirection),y+lengthdir_y(25,aimDirection),AirBlastO);
                            if (image_xscale == 1) {
                                poof.image_xscale = 1;
                                poof.image_angle = aimDirection;
                            } else {
                                poof.image_xscale = -1;
                                poof.image_angle = aimDirection+180;
                            }
                            
                            with(nearestTarget) {
                                if (object_is_ancestor(object_index, Character)) motion_set(other.aimDirection, 12);
                                if (object_index == MOBAbot) {
                                    motion_set(other.aimDirection, 12);
                                    state = 0;
                                    alarm[9] = 10 / global.delta_factor;
                                }
                            }
                            
                            shooting = false;
                            canAirblast = 0;
                            alarm[4] = airblastTime / global.delta_factor;
                            alarm[1] = 30 / global.delta_factor;     
                                               
                        } else if(nearestTarget.ubered == 0) {
                            damageAuto(id, nearestTarget, hitDamage*4);
                            if (nearestTarget.lastDamageDealer != ownerPlayer && object_is_ancestor(nearestTarget.object_index, Character)) {
                                if (nearestTarget.lastDamageDealer != nearestTarget.player){
                                    nearestTarget.secondToLastDamageDealer = nearestTarget.lastDamageDealer;
                                    nearestTarget.alarm[4] = nearestTarget.alarm[3];
                                }
                            }
                            nearestTarget.alarm[3] = ASSIST_TIME;
                            nearestTarget.lastDamageDealer = id;
                            nearestTarget.lastDamageSource = 4152;
                            shooting = true;
                        }
                        
                        if(global.particles == PARTICLES_NORMAL) {
                            repeat(2) effect_create_below(ef_smokeup, x+lengthdir_x(random(140),aimDirection), y-8+lengthdir_y(random(140),aimDirection), 0, c_gray);
                        }
                        
                        if (point_distance(x, y, nearestTarget.x, nearestTarget.y) < 70) state = 2;
                        else state = 0;
                        
                        if (alarm[1] < 0) oldDir = dir;
                        alarm[1] = 15 / global.delta_factor;
                        if(((aimDirection+270) mod 360)>180) {
                            dir=1;
                            drawDirection = aimDirection;
                        } else {
                            dir=-1;
                            drawDirection = aimDirection+180;
                        }
                    } else {
                        shooting = 0;
                        canAirblast = 0;
                    }
                } else if (super == 2 && (other.frame mod 45) == 0 && global.isHost) {
                    nearestTarget = noone;
                    targetQueue = ds_priority_create();
                    
                    // Build a queue of potential targets
                    with(Character) {
                        testDist = distance_to_object(other);
                        if((!cloak || stabbing) && testDist<=100 && player.team != other.team) {
                            ds_priority_add(targetQueue, id, testDist);
                        }
                    }
                    
                    while(!nearestTarget && !ds_priority_empty(targetQueue)) {
                        playercheck = ds_priority_delete_min(targetQueue);
                        if(collision_line(x,y,playercheck.x,playercheck.y,Obstacle,true,true)<0
                            && collision_line(x,y,playercheck.x,playercheck.y,IntelGate,true,true)<0
                            && collision_line(x,y,playercheck.x,playercheck.y,BulletWall,true,true)<0) {
                            nearestTarget = playercheck;
                        }
                    }
                
                    ds_priority_destroy(targetQueue);
                    
                    if (nearestTarget) {
                        state = 1;
                        aimDirection = 90 + (x-nearestTarget.x)/5;
                        var shot;
                        shot = instance_create(x, y, MOBAcannonball);
                        shot.direction = aimDirection;
                        shooting = true;
                        alarm[10] = 70 / global.delta_factor;
                        shield = false;
    
                        oldDir = dir;
                        if(((aimDirection+270) mod 360)>180) {
                            dir = 1;
                        } else {
                            dir = -1;
                        }
                        
                        var buffer;
                        buffer = buffer_create();
                        write_ubyte(buffer, 9);
                        PluginPacketSend(global.GNPacketID, buffer);
                        buffer_destroy(buffer);
                    } else {
                        if (shooting) dir = oldDir;
                        shooting = false;
                        state = 0;
                    }
                }
            }
        }
        hspeed *= global.delta_factor;
        vspeed *= global.delta_factor;
        
        onFloor = !place_free(x,y+1);
        blocked = !place_free(x+hspeed, y+vspeed);
        corrected = 0;

        // Collide
        if(blocked) {
            stuck = !place_free(x, y);
            
            // We are hitting the floor or are completely stuck
            if(place_free(x+hspeed, y) || stuck) {
                if (vspeed > 0) {
                    // push up
                    y -= 7;
                    move_contact_solid(270, vspeed + 6);
                    jumping = false;
                    corrected = 1;
                }
                vspeed = 0;
            }
            
            // there is something else blocking us.
            if (!corrected) {
                // A step
                if (place_free(x + hspeed, y + vspeed - 6)) {
                    y -= 6;
                    blocked = 0;
                } else {  
                    // A bigger object we can jump over
                    canJump = !jumping && (place_free(x+hspeed, y+vspeed-60) || place_free(x+hspeed, y+vspeed-36));
                    
                    // Try jumping
                    if (canJump && onFloor && state != 1) {
                        jumpNow = true;
                        jumping = true;
                    }
                    
                    // A wall we cannot jump over
                    else if (vspeed == 0 && !jumping && onFloor) {
                        hspeed *= -1;
                        dir *= -1;
                    }
                }
            }
        }
        
        hspeed /= global.delta_factor;
        vspeed /= global.delta_factor;

        // apply gravity
        if (!onFloor) vspeed += 0.6  * global.delta_factor; 
        if (jumpNow) {
            vspeed -= 8;
            jumpNow = false;
        }

        // Do not try moving sideways when there is a wall blocking us
        if (!blocked && !humiliated && (state == 0 || (state == 2 && jumping))) x += hspeed * global.delta_factor;
        canMove = true;
        
        x -= hspeed;
        y -= vspeed;
        y += vspeed * global.delta_factor;
        
    }
    
    // Make turrets shoot
    if ((other.frame mod 6) == 0 && global.run_virtual_ticks) {
        with(MOBAturret) {
            if (destroyed) continue;
    
            if(((aimDirection+270) mod 360)>180) {
                gunXScale=1;
                drawDir = aimDirection;
            } else {
                gunXScale=-1;
                drawDir = aimDirection+180;
            }
            
            nearestTarget = noone;
            targetQueue = ds_priority_create();
            
            // Build a queue of potential targets
            with(Character) {
                testDist = distance_to_object(other);
                if(!cloak && testDist<=325 && player.team != other.team) {
                    ds_priority_add(targetQueue, id, testDist+250);
                }
            }
            
            with(Sentry) {
                testDist = distance_to_object(other);
                if(testDist<=325 && team != other.team) {
                    ds_priority_add(targetQueue, id, testDist+250);
                }
            }
            
            with(Generator) {
                testDist = distance_to_object(other);
                if(testDist<=250 && team != other.team) {
                    ds_priority_add(targetQueue, id, testDist);
                }
            }
            
            while(!nearestTarget && !ds_priority_empty(targetQueue)) {
                playercheck = ds_priority_delete_min(targetQueue);
                if(collision_line(x,y-31,playercheck.x,playercheck.y,Obstacle,true,true)<0
                    && collision_line(x,y-31,playercheck.x,playercheck.y,IntelGate,true,true)<0
                    && collision_line(x,y-31,playercheck.x,playercheck.y,BulletWall,true,true)<0) {
                    nearestTarget = playercheck;
                }
            }
        
            ds_priority_destroy(targetQueue);
            
            // Shoot enemies that are shooting at us outside normal range
            if (!nearestTarget && trueTarget) {
                if (instance_exists(trueTarget)) {
                    if (collision_line(x,y-31,trueTarget.x,trueTarget.y,Obstacle,true,true)<0
                        && collision_line(x,y-31,trueTarget.x,trueTarget.y,IntelGate,true,true)<0
                        && collision_line(x,y-31,trueTarget.x,trueTarget.y,BulletWall,true,true)<0) {
                        nearestTarget = trueTarget;
                    } else trueTarget = noone;
                } else trueTarget = noone;
            } else trueTarget = noone;
            
            if(!nearestTarget) {
                if(image_xscale>0) aimDirection = 0;
                else aimDirection = 180;
            } else {
                // set cloaked spy as target if theyre in the way
                with(Spy) {
                    if(team != other.team && collision_line(other.x,other.y-31,other.nearestTarget.x,other.nearestTarget.y,id,true,false)>=0) {
                        other.nearestTarget = id;
                    }
                } 
                
                aimDirection = point_direction(x,y-31,nearestTarget.x,nearestTarget.y);
                
                playsound(x,y,ShotgunSnd);
                if(nearestTarget.ubered == 0) {
                    damageAuto(id, nearestTarget, hitDamage);
                    if (nearestTarget.lastDamageDealer != ownerPlayer && object_is_ancestor(nearestTarget.object_index, Character)) {
                        if (nearestTarget.lastDamageDealer != nearestTarget.player){
                            nearestTarget.secondToLastDamageDealer = nearestTarget.lastDamageDealer;
                            nearestTarget.alarm[4] = nearestTarget.alarm[3];
                        }
                    }
                    nearestTarget.alarm[3] = ASSIST_TIME;
                    nearestTarget.lastDamageDealer = noone;
                    nearestTarget.lastDamageSource = 4151;
                    if(global.gibLevel > 0 and object_is_ancestor(nearestTarget.object_index, Character))
                    {
                        blood = instance_create(nearestTarget.x,nearestTarget.y,Blood);
                        blood.direction = direction-180;
                        dealFlicker(nearestTarget);
                    }
                    if (nearestTarget.object_index == MOBAbot) {
                        shield = 0;
                        alarm[2] = 60 / global.delta_factor;
                    }
                } else {
                    if (object_is_ancestor(nearestTarget.object_index, Medic)) {
                        if (nearestTarget.currentWeapon.ubering) nearestTarget.currentWeapon.uberCharge -= 50;
                    }
                    if (nearestTarget.healer != -1 && instance_exists(nearestTarget.healer)) {
                        if (nearestTarget.healer.object != -1 && instance_exists(nearestTarget.healer.object)) {
                            if (nearestTarget.healer.object.currentWeapon.ubering) nearestTarget.healer.object.currentWeapon.uberCharge -= 50;
                        }
                    }
                }
                shooting=true;
            }
        }
    }
    with(MOBAwall) solid = false;
    gunUnsetSolids();
');
    
object_event_add(MOBAcontroller, ev_alarm, 0,'
    /** this executes at the wrong time, do this in the begin step instead
    //Tell the clients to spawn bots too
    var buffer;
    buffer = buffer_create();
    write_ubyte(buffer, 4);
    PluginPacketSend(global.GNPacketID, buffer);
    buffer_destroy(buffer);

    alarm[0] = respawnTime;
    event_user(0);
    */
');

object_event_add(MOBAcontroller, ev_other, ev_user0, '
    if (first) {
        playsound(view_xview[0]+view_wview[0]/2, view_yview[0]+view_hview[0]/2, SirenSnd);
        with(NoticeO) instance_destroy();
        instance_create(0,0,NoticeO);
        NoticeO.notice = NOTICE_CUSTOM;
        NoticeO.message = "Bots have spawned";
        first = false;
    }
    
    // Normal bots
    if (instance_number(MOBAbot) < MOBA.botLimit && type == 0) {
        var bot;  
        with(MOBAspawn) {
            switch(type) {
                case 0:
                    bot = instance_create(x, y, MOBAbot);
                    bot.dir = 1;
                    bot.direction = 0;
                    bot.team = TEAM_RED;
                break;
                case 2:
                    bot = instance_create(x, y, MOBAbot);
                    bot.dir = -1
                    bot.direction = 180;
                    bot.team = TEAM_BLUE;
                break;
                case 4:
                    if (!instance_exists(creep)) {
                        bot = instance_create(x, y, MOBAbot);
                        bot.dir = choose(-1, 1);
                        bot.direction = -bot.dir*90+90;
                        bot.team = 2;              
                        creep = bot;
                    }
                break;
            }
        }
    // Team superbots
    } else if (type == 1) {
        if (redSuperQueue > 0) {
            redSuperQueue -= 1;
            with(MOBAspawn) {
                if (type == 1) {
                    bot = instance_create(x, y, MOBAbot);
                    bot.dir = 1;
                    bot.direction = 0;
                    bot.team = TEAM_RED;
                    bot.super = 1;
                    bot.maxHp = 200;
                    bot.hp = 200;
                }
            }
        }
        if (blueSuperQueue > 0) {
            blueSuperQueue -= 1;
            with(MOBAspawn) {
                if (type == 3) {
                    bot = instance_create(x, y, MOBAbot);
                    bot.dir = -1;
                    bot.direction = 180;
                    bot.team = TEAM_BLUE;
                    bot.super = 1;
                    bot.maxHp = 200;
                    bot.hp = 200;
                }
            }
        }
    // neutral superbots
    } else if (type == 2) {
        with(MOBAspawn) {
            if (type == 5) {
                if (!instance_exists(creep)) {
                    bot = instance_create(x, y, MOBAbot);
                    bot.dir = choose(-1, 1);
                    bot.direction = -bot.dir*90+90;
                    bot.team = 2;
                    bot.super = 2;
                    bot.runPower = 0.2;
                    bot.maxHp = 250;
                    bot.hp = 250;
                    bot.shield = true;
                    creep = bot;
                }
            }
        }
    }
');

// Place all MOBA entities 
object_event_add(MOBAcontroller, ev_other, ev_user1, '
    with(Player) {
        for(i=0; i<8; i+=1) GNupgrades[i] = false;
        spentPoints = 0; 
    }

    with(Generator) {
        maxHp = 1000;
        hp = maxHp;
        regenerationBuffer = 30;
        maxShieldResistance = 1;
        maxShieldHp = 600;
        shieldHp = maxShieldHp;
        ubered = 0;
    }
    
    with(SpawnPointRed1) {
        var bot;
        bot = instance_create(x, y, MOBAturret);
        bot.team = TEAM_RED;
        instance_destroy();
    }
    with(SpawnPointBlue1) {
        var bot;
        bot = instance_create(x, y, MOBAturret);
        bot.team = TEAM_BLUE;
        bot.image_xscale = -1;
        instance_destroy();
    }
    with(SpawnPointRed2) {
        entity = instance_create(x, y, MOBAspawn);
        entity.type = 0;
        entity = instance_create(x, y, MOBAspawn);
        entity.type = 1;
        instance_destroy();
    }
    with(SpawnPointBlue2) {
        entity = instance_create(x, y, MOBAspawn);
        entity.type = 2;
        entity = instance_create(x, y, MOBAspawn);
        entity.type = 3;
        instance_destroy();
    }
    with(SpawnPointRed3) {
        entity = instance_create(x, y, MOBAentity);
        entity.type = 10;
        instance_destroy();
    }
    with(SpawnPointBlue3) {
        entity = instance_create(x, y, MOBAentity);
        entity.type = 11;
        instance_destroy();
    }
    with(SpawnPointRed4) {
        entity = instance_create(x, y, MOBAentity);
        entity.type = 16;
        instance_destroy();
    }
    with(SpawnPointBlue4) {
        entity = instance_create(x, y, MOBAentity);
        entity.type = 17;
        instance_destroy();
    }
    
    with(CaptureZone) {
        entity = instance_create(x, y+10, MOBAentity);
        entity.type = 18;
        entity = instance_create(x, y+10, MOBAentity);
        entity.type = 20;
        instance_destroy();
    }
');

/****************************************
 * placeholder MOBA turret
****************************************/
globalvar MOBAturretDummy;
MOBAturretDummy = object_add();
object_event_add(MOBAturretDummy, ev_create, 0, '
    image_speed = 0;
    sprite_index = MOBAturretBaseS;
');

/****************************************
 * MOBA turrets
****************************************/
globalvar MOBAturret;
MOBAturret = object_add();
object_set_parent(MOBAturret, Generator);
object_set_mask(MOBAturret, MOBAturretBaseS);

object_event_add(MOBAturret, ev_create, 0, '
    hp = 1500;
    maxHp = hp;
    team = TEAM_RED;
    alarm[10] = 1;
    wall = noone;
    destroyed = false;
    ownerPlayer = noone;    //Required for sentry objects
    humiliated = 0;
    nearestTarget = noone;
    hitDamage = 9;
    refireTime = 6;
    aimDirection = 0;
    gunXScale = 1;
    shooting=true;
    readyToShoot=false;
    trueTarget = noone;
    drawDir = 0;
    ubered = 0;
    shield = 1;
    shieldIndex = 5;
    first = true;
    shieldResistance = 0;
    regenerationBuffer = 0;
    shieldHp = 0;

    object = id;
    healer = noone;
    name = "a turret";
    stats[KILLS] = 0;
    stats[ASSISTS] = 0;
    stats[DESTRUCTION] = 0;
    stats[DEFENSES] = 0;
    stats[BONUS] = 0;
    stats[POINTS] = 0;
    roundStats[KILLS] = 0;
    roundStats[ASSISTS] = 0;
    roundStats[DESTRUCTION] = 0;
    roundStats[DEFENSES] = 0;
    roundStats[BONUS] = 0;
    roundStats[POINTS] = 0;
');
object_event_add(MOBAturret, ev_destroy, 0, '//nope');
object_event_add(MOBAturret, ev_step, ev_step_normal, '//nope');

object_event_add(MOBAturret, ev_other, ev_user12, '
    if (!MOBA.sync) exit;
    write_ubyte(global.MOBAbuffer, ceil(hp/5.9));
');

object_event_add(MOBAturret, ev_other, ev_user13, '
    if (!MOBA.sync) exit;
    hp = read_ubyte(global.MOBAbuffer)*5.9;
    
    if (hp <= 0 && !destroyed) {
        hp = 0;
        destroyed = true;
        if (instance_exists(wall)) with(wall) instance_destroy();
        dummy = instance_create(x,y, MOBAturretDummy);
        dummy.image_index = team*2 + 1;
        dummy.image_xscale = image_xscale;
        
        if (!first) {
            instance_create(x, y, Explosion);
            playsound(x, y, ExplosionSnd);
            with(Player) {
                if (team != other.team) stats[POINTS] += 4;
            }
            
            with(KillLog) {
                var map;
                map = ds_map_create();
                ds_map_add(map, "name1", "A turret");
                ds_map_add(map, "team1", other.team);           
                ds_map_add(map, "name2", "");
                ds_map_add(map, "team2", other.team);
                ds_map_add(map, "inthis", true);
                ds_map_add(map, "string", " has been destroyed!");
                ds_map_add(map, "weapon", ExplodeKL);
                ds_list_add(kills, map);
                
                if (ds_list_size(kills) > 5) {
                    ds_map_destroy(ds_list_find_value(kills, 0));
                    ds_list_delete(kills, 0);
                }
                
                alarm[0] = 30*5;
            }
        }
        
        // Hide these because they are still needed for syncing
        oldX = x;
        oldY = y;
        x = -100;
        y = -100;
        visible = false;
    } else if (destroyed && hp > 0) {   // no idea why it happens, but it does
        visisble = 1;
        x = oldX;
        y = oldY;
        destroyed = 0;
        with(dummy) instance_destroy();
        alarm[10] = 1;
    }
    
    first = false;
');

object_event_add(MOBAturret, ev_alarm, 10, '
    if (team == TEAM_RED) wall = instance_create(x, y-37, RedTeamGate);
    else {
        wall = instance_create(x, y-37, BlueTeamGate);
        image_xscale = -1;
    }
');

object_event_add(MOBAturret, ev_step, ev_step_begin, '
    if (hp <= 0 && !destroyed && global.isHost) {
        hp = 0;
        destroyed = true;
        if (instance_exists(wall)) with(wall) instance_destroy();
        dummy = instance_create(x,y, MOBAturretDummy);
        dummy.image_index = team*2 + 1;
        dummy.image_xscale = image_xscale;
        
        instance_create(x, y, Explosion);
        playsound(x, y, ExplosionSnd);
        
        with(KillLog) {
            var map;
            map = ds_map_create();
            ds_map_add(map, "name1", "A turret");
            ds_map_add(map, "team1", other.team);           
            ds_map_add(map, "name2", "");
            ds_map_add(map, "team2", other.team);
            ds_map_add(map, "inthis", true);
            ds_map_add(map, "string", " has been destroyed!");
            ds_map_add(map, "weapon", ExplodeKL);
            ds_list_add(kills, map);
            
            if (ds_list_size(kills) > 5) {
                ds_map_destroy(ds_list_find_value(kills, 0));
                ds_list_delete(kills, 0);
            }
            
            alarm[0] = 30*5;
        }
        
        // Hide these because they are still needed for syncing
        x = -100;
        y = -100;
        visible = false;
        
        with(Player) {
            if (team != other.team) stats[POINTS] += 4;
        }
    }
');
object_event_add(MOBAturret, ev_alarm, 0, 'readyToShoot = true;');
object_event_add(MOBAturret, ev_alarm, 1, 'trueTarget = noone;');
object_event_add(MOBAturret, ev_alarm, 2, 'shield = 1;');

object_event_add(MOBAturret, ev_collision, Mine, ' 
    if(team != other.team){
        if (x<other.x) with(other) motion_set(50, 4);
        else with(other) motion_set(130, 4); 
        other.stickied = false;
        playsound(x, y, CompressionBlastSnd);
    }
');

object_event_add(MOBAturret, ev_draw, 0, '
    if (distance_to_point(view_xview + view_wview/2, view_yview + view_hview/2) > 800) exit;
    
    draw_sprite_ext(MOBAturretBaseS, team*2 + destroyed, x, y, image_xscale, 1, 0, c_white, 1);
    if (!destroyed) {
        draw_set_alpha(1);
        draw_healthbar(x-15, y-50, x+15, y-45,hp/maxHp*100,c_black,c_red,c_green,0,true,true);
        
        draw_sprite_ext(MOBAturretS, shooting + team*2, x, y-31, gunXScale, 1, drawDir, c_white, 1);
        if (shooting) {
            if(instance_exists(nearestTarget)){
                xshootoffset=4*gunXScale;
                draw_set_alpha(0.6);
                draw_line_width_color(x+lengthdir_x(10,aimDirection)-xshootoffset,y+lengthdir_y(10,aimDirection)-29,nearestTarget.x+random(25)-12,nearestTarget.y+random(25)-12,2,c_yellow,c_black);
            }
            shooting=false;
        }
        
        if (shield) {
            if (shieldIndex >= 5) draw_sprite_ext(GNturretShieldS, 0, x, y-10, -image_xscale, 1, 0, c_white, 0.5);
            else {
                shieldIndex += 0.3 * global.delta_factor;
                draw_sprite_ext(GNturretShieldS, floor(shieldIndex), x, y-10, -image_xscale, 1, 0, c_white, 1);
            }
        }
    }
');

/****************************************
 * Moba (super) droids
****************************************/
globalvar MOBAbot;
MOBAbot = object_add();
object_set_parent(MOBAbot, Generator);
object_set_mask(MOBAbot, MOBAbotMoveS)
object_event_add(MOBAbot, ev_destroy, 0, '//nope');
object_event_add(MOBAbot, ev_other, ev_user12, '
    if (!MOBA.sync) exit;
    
    write_ushort(global.MOBAbuffer, round(x*5))
    write_ushort(global.MOBAbuffer, round(y*5));
    //write_byte(global.MOBAbuffer, round(vspeed*8.5));
    write_ubyte(global.MOBAbuffer, ceil(hp));
    temp = 0;
    temp |= min(3, state);
    temp |= min(3, super) << 2;
    temp |= min(3, team) << 4;
    if (dir == 1) temp |= $40;
    if (followNavBox) temp |= $80;
    write_ubyte(global.MOBAbuffer, temp);
');
object_event_add(MOBAbot, ev_other, ev_user13, '
    if (!MOBA.sync) exit;
    
    x = read_ushort(global.MOBAbuffer)/5;
    y = read_ushort(global.MOBAbuffer)/5;
    //vspeed = read_byte(global.MOBAbuffer)/8.5;
    hp = read_ubyte(global.MOBAbuffer);
    temp = read_ubyte(global.MOBAbuffer);
    state = temp & $03;
    super = (temp >> 2) & $03;
    team = (temp >> 4) & $03;
    if (temp & $40 != 0) dir = 1;
    else dir = -1;
    followNavBox = (temp & $80 != 0);
    
    if (super == 2) {
        runPower = 0.2;
        if (state == 0) shooting = false;
    }
');
object_event_add(MOBAbot, ev_collision, KillBox, 'hp = 0;');
object_event_add(MOBAbot, ev_collision, FragBox, 'hp = 0;');

object_event_add(MOBAbot, ev_create, 0, '
    team = TEAM_RED;
    runPower = 4;
    sprite_index = SentryRed;
    jumping = false;
    canMove = false;
    animIndex = 0;
    dir = 1;
    state = 0;
    idle = false;
    hp = 100;
    maxHp = 100;
    ownerPlayer = noone;    // Required for sentry objects
    lastDamageDealer = noone;
    oldDir = 1;
    damage = 20;
    super = 0;
    humiliated = 0;
    touchToggle = 0;
    touchedNavBox = 0;
    followNavBox = 1;
    shield = 0;
    shieldIndex = 0;
    ubered = 0;
    shieldResistance = 0;
    regenerationBuffer = 0;
    shieldHp = 0;
    fireIndex = 0;
        
    shooting = 0;
    aimDirection = 0;
    readyToShoot = 1;
    canAirblast = 0;
    refireTime = 2;
    airblastTime = 45;
    baseAimDir = random(100)-50;
    wiggle = 0;
    wiggleDir = 1;
    aimDirection = baseAimDir;
    drawDirection = baseAimDir;
    hitDamage = 3;
    
    object = id;
    healer = noone;
    name = "a droid";
    stats[KILLS] = 0;
    stats[ASSISTS] = 0;
    stats[DESTRUCTION] = 0;
    stats[DEFENSES] = 0;
    stats[BONUS] = 0;
    stats[POINTS] = 0;
    roundStats[KILLS] = 0;
    roundStats[ASSISTS] = 0;
    roundStats[DESTRUCTION] = 0;
    roundStats[DEFENSES] = 0;
    roundStats[BONUS] = 0;
    roundStats[POINTS] = 0;
');

object_event_add(MOBAbot, ev_step, ev_step_normal, '//nope');
object_event_add(MOBAbot, ev_step, ev_step_begin, '
    if (hp <= 0) {
        instance_destroy();
        instance_create(x, y, Explosion);
        playsound(x,y, ExplosionSnd);
        
        if (lastDamageDealer != noone && instance_exists(lastDamageDealer)) {
            if (lastDamageDealer.object_index == Player) {
                lastDamageDealer.stats[POINTS] += 0.5 + (super > 0)*0.5;
                if (super == 2) with(Player) if (team == other.lastDamageDealer.team) stats[POINTS] += 1;
                
                if (instance_exists(lastDamageDealer.object) && lastDamageDealer.object != -1 && team == 2) {
                    if (super == 2) lastDamageDealer.object.hp = lastDamageDealer.object.maxHp;
                    else lastDamageDealer.object.hp = min(lastDamageDealer.object.maxHp, lastDamageDealer.object.hp + 30);
                }
            }
        } 
    }
    
    if (super == 2 && team == 2) {
        hp = min(maxHp, hp + 1*global.delta_factor);
        if (shield) shieldHp = 5000;
        else shieldHp = 0;
    }
    
    targetSpeed = runPower * dir;
    if (abs(targetSpeed - hspeed) < 0.5*global.delta_factor) hspeed = targetSpeed;
    else hspeed += sign(targetSpeed-hspeed)*global.delta_factor;
    
    if (state == 0) {   //walking
        animIndex += 0.25 * global.delta_factor;
        if (animIndex >= 4) animIndex = 0;
        else if (animIndex < 0) animIndex = 4;
        if (super && !shooting) {
            drawDirection = baseAimDir + wiggle;
            if (super == 2) drawDirection += 90;
            wiggle += wiggleDir * global.delta_factor;
            if (wiggle > 10 && wiggleDir > 0) wiggleDir = -1;
            else if (wiggle < -10 && wiggleDir < 0) wiggleDir = 1;
        }
    } else if (state == 1) {    //attacking
        if (!super) {
            animIndex += 0.5 * global.delta_factor;
            if (animIndex >= 14)  {
                state = 0;
                animIndex = 0;
                dir = oldDir;
            }
        }
        drawDirection = aimDirection;
    }
');
object_event_add(MOBAbot, ev_alarm, 1, '
    state = 0;
    dir = oldDir;
    drawDirection = baseAimDir;
');
object_event_add(MOBAbot, ev_alarm, 2, 'readyToShoot = true');
object_event_add(MOBAbot, ev_alarm, 3, 'loopsoundstop(FlamethrowerSnd);');
object_event_add(MOBAbot, ev_alarm, 4, 'canAirblast = true;');
object_event_add(MOBAbot, ev_alarm, 6, 'event_user(6)');
object_event_add(MOBAbot, ev_alarm, 7, 'touchToggle = false;');
object_event_add(MOBAbot, ev_alarm, 8, 'shield = false;');
object_event_add(MOBAbot, ev_alarm, 9, 'state = 0;');
object_event_add(MOBAbot, ev_alarm, 10, 'shield = true;');

object_event_add(MOBAbot, ev_other, ev_user3, '
    // Try jumping
    if (!jumping && state != 1 && onFloor) {
        vspeed -= 8;
        jumping = true;
    } else if (!onFloor && !jumping) {
        hspeed = 0;
    }
');
object_event_add(MOBAbot, ev_other, ev_user6, '
    if (state == 0) exit;
    var attacked;
    attacked = false;
    with(Character) {
        if (player.team != other.team && ubered == 0) {
            if (abs(y-other.y) < 40 && ((other.dir == 1 && x-other.x > -5 && x-other.x < 45) || (other.dir == -1 && other.x-x > -5 && other.x-x < 45))) {
                damageCharacter(other.id, id, other.damage);
                lastDamageDealer = noone;
                lastDamageSource = 4150;
                dealFlicker(id);
                repeat(3) {
                    var blood;
                    blood = instance_create(other.x + 30*other.dir, other.y, Blood);
                    blood.direction = random(360);
                }
                motion_add(-other.dir*90+90, 0.7);
                attacked = true;
                break;
            }
        }
    }
    if (!attacked) {
        with(Sentry) {
            if (team != other.team && hp > 0) {
                if (abs(y-other.y) < 40 && ((other.dir == 1 && x-other.x > -5 && x-other.x < 45) || (other.dir == -1 && other.x-x > -5 && other.x-x < 45))) {
                    damageSentry(other.id, id, other.damage);
                    lastDamageDealer = noone;
                    lastDamageSource = 4150;	
                    attacked = true;
                    break;
                }
            }
        }
    }
    if (!attacked) {
        with(Generator) {
            if (team != other.team) {
                if (abs(y-other.y) < 40 && ((other.dir == 1 && x-other.x > -5 && x-other.x < 45) || (other.dir == -1 && other.x-x > -5 && other.x-x < 45))) {
                    damageGenerator(other.id, id, other.damage);
                    attacked = true;
                    break;
                }
            }
        }
    }
');

//Shoot clientside
object_event_add(MOBAbot, ev_other, ev_user7, '
    var nearestTarget, targetQueue;
    nearestTarget = noone;
    targetQueue = ds_priority_create();
    
    // Build a queue of potential targets
    with(Character) {
        testDist = distance_to_object(other);
        if((!cloak || stabbing) && testDist<=100 && player.team != other.team) {
            ds_priority_add(targetQueue, id, testDist);
        }
    }
    
    while(!nearestTarget && !ds_priority_empty(targetQueue)) {
        playercheck = ds_priority_delete_min(targetQueue);
        if(collision_line(x,y,playercheck.x,playercheck.y,Obstacle,true,true)<0
            && collision_line(x,y,playercheck.x,playercheck.y,IntelGate,true,true)<0
            && collision_line(x,y,playercheck.x,playercheck.y,BulletWall,true,true)<0) {
            nearestTarget = playercheck;
        }
    }

    ds_priority_destroy(targetQueue);
    
    if (nearestTarget) {
        state = 1;
        aimDirection = 90 + (x-nearestTarget.x)/5;
        var shot;
        shot = instance_create(x, y, MOBAcannonball);
        shot.direction = aimDirection;
        shooting = true;
        alarm[10] = 70 / global.delta_factor;
        shield = false;

        oldDir = dir;
        if(((aimDirection+270) mod 360)>180) {
            dir = 1;
        } else {
            dir = -1;
        }
    } else {
        if (shooting) dir = oldDir;
        shooting = false;
        state = 0;
    }
');

// Some map entites change the default behaviour
object_event_add(MOBAbot, ev_collision, MOBAentity, '
    switch(other.type) {
        case 6: if (dir == 1 && team == TEAM_RED && followNavBox) event_user(3); break;
        case 7: if (dir == -1 && team == TEAM_RED && followNavBox) event_user(3); break;
        case 8: if (dir == 1 && team == TEAM_BLUE && followNavBox) event_user(3); break;
        case 9: if (dir == -1 && team == TEAM_BLUE && followNavBox) event_user(3); break;
        case 10: if (dir == 1 && followNavBox) event_user(3); break;
        case 11: if (dir == -1 && followNavBox) event_user(3); break;
        case 12: if (team == TEAM_RED && followNavBox) dir = 1; break;
        case 13: if (team == TEAM_RED && followNavBox) dir = -1 break;
        case 14: if (team == TEAM_BLUE && followNavBox) dir = 1 break;
        case 15: if (team == TEAM_BLUE && followNavBox) dir = -1 break;
        case 16: if (followNavBox) dir = 1 break;
        case 17: if (followNavBox) dir = -1 break;
        case 18: 
            if (team == TEAM_RED) {
                alarm[7] = 2;
                if (!touchToggle) {
                    touchToggle = true;
                    if (!other.lastChanged) followNavBox = 0;
                    other.lastChanged = !other.lastChanged; 
                }
            }
        break;
        case 19: if (team == TEAM_RED) followNavBox = 1; break;
        case 20: 
            if (team == TEAM_BLUE) {
                alarm[7] = 2;
                if (!touchToggle) {
                    touchToggle = true;
                    if (!other.lastChanged) followNavBox = 0;
                    other.lastChanged = !other.lastChanged; 
                }
            }
        break;
        case 21: if (team == TEAM_BLUE) followNavBox = 1; break;
        case 22: 
            alarm[7] = 2;
            if (!touchToggle) {
                touchToggle = true;
                if (!other.lastChanged) followNavBox = 0;
                other.lastChanged = !other.lastChanged; 
            }
        break;
        case 23: followNavBox = 1; break;
    }
');

object_event_add(MOBAbot, ev_collision, MOBAmoveBox, 'motion_set(other.dir, 7);');

object_event_add(MOBAbot, ev_destroy, 0, '
    //loopsoundstop(FlamethrowerSnd);
    with(Flame) {
        if (ownerPlayer == other.id) instance_destroy();
    }
    
    // Even out small differences in timing
    if (alarm[6] <= 3/global.delta_factor && alarm[6] > 0) {
        event_user(6);
    }
');

object_event_add(MOBAbot, ev_draw, 0, '
    if (distance_to_point(view_xview + view_wview/2, view_yview + view_hview/2) > 800) exit;
    
    if (!super) {
        if (team == 2) draw_sprite_ext(MOBAcreepS, floor(animIndex), x+5*dir, y, dir, 1, 0, c_white, 1);
        else {
            if (state == 0) draw_sprite_ext(MOBAbotMoveS, team*4+floor(animIndex), x+5*dir, y, dir, 1, 0, c_white, 1);
            else draw_sprite_ext(MOBAbotMeleeS, team*14+floor(animIndex), x+5*dir, y, dir, 1, 0, c_white, 1);
        }
    } else if (super == 1) {
        draw_sprite_ext(MOBAbotMove2S, team*4+floor(animIndex), x+5*dir, y, dir, 1, 0, c_white, 1);
        if (!shooting) draw_sprite_ext(FlamethrowerS, team, x, y, dir, 1, drawDirection, c_white, 1);
        else {
            draw_sprite_ext(FlamethrowerFS, team*3 + 1, x, y, dir, 1, drawDirection, c_white, 1);
            draw_sprite_ext(MOBAphlogS, fireIndex, x+lengthdir_x(20, aimDirection), y+lengthdir_y(20, aimDirection), 0.9, 0.9, aimDirection, c_white, 0.8);
            fireIndex += 0.3 * global.delta_factor;
            if (fireIndex >= 4) fireIndex = 0;
        }
    } else if (super == 2) {
        draw_sprite_ext(MOBAcreepCannonS, 0, x+4*dir, y-10, dir*2, 2, drawDirection-90, c_white, 1);
        
        if (state == 0) draw_sprite_ext(MOBAcreepMoveS, floor(animIndex), x, y, dir, 1, 0, c_white, 1);
        else draw_sprite_ext(MOBAcreepStillS, floor(animIndex), x, y, dir, 1, 0, c_white, 1);
    }
    
    if (shield) {
        if (super == 2) draw_sprite_ext(GNturretShieldS, 0, x, y-18, 2, 0.8, 0, c_white, 1);
        else {
            draw_sprite_ext(GNheavyShieldS, floor(shieldIndex) + team*2, x-4, y, 1.3, 1.3, 0, c_white, 0.5);
            shieldIndex += 0.2 * global.delta_factor;
            if (shieldIndex >= 2) shieldIndex = 0;
        }
    }
    
    draw_set_alpha(1);
    draw_healthbar(x-10, y-30, x+10, y-25,hp/maxHp*100,c_black,c_red,c_green,0,true,true);
');