globalvar GNsniperBomb;
GNsniperBomb = object_add();

object_event_add(GNsniperBomb, ev_create, 0, '
    speed = 8;
    sprite_index = SentryRed;
    animIndex = 0;
    ticks = 0;

    wallSetSolid();
    // Try to get outside of the wallmask if were in it.
    if(!place_free(x, y))
        move_outside_solid(0, 6);
    if(!place_free(x, y))
        move_outside_solid(180, 12);
    if(!place_free(x, y))
    {
        move_outside_solid(0, 6);
    }
    wallUnsetSolid();
    
    locked = ds_list_create();
    alarm[0] = 120/global.delta_factor;
');

object_event_add(GNsniperBomb, ev_alarm, 0, '
    instance_destroy();
    instance_create(x,y,Explosion);
    playsound(x, y, ExplosionSnd);
    ds_list_destroy(locked);
');

object_event_add(GNsniperBomb, ev_step, ev_step_begin, '
    if (hspeed == 0 && vspeed == 0) {
        if (animIndex < 4) animIndex += 0.2 * global.delta_factor;
        with(Character) {
            if (team != other.ownerPlayer.team && ubered == 0) {
                if (point_distance(x, y, other.x, other.y) <= 128 && ds_list_find_index(other.locked, id) == -1) {
                    if (collision_line(x, y, other.x, other.y, Obstacle, 1, 1) <= 0) ds_list_add(other.locked, id);
                }
            }
        }
        with(MOBAbot) {
            if (team != other.ownerPlayer.team) {
                if (point_distance(x, y, other.x, other.y) <= 128 && ds_list_find_index(other.locked, id) == -1) {
                    if (collision_line(x, y, other.x, other.y, Obstacle, 1, 1) <= 0) ds_list_add(other.locked, id);
                }
            }
        }
        
        ticks += 1;
        for(i=ds_list_size(locked)-1; i>=0; i-=1) {
            object = ds_list_find_value(locked, i);
            if (!instance_exists(object)) ds_list_delete(locked, i);
            else {
                // pull the target back;
                dist = point_distance(x, y, object.x, object.y);
                dir = point_direction(x, y, object.x, object.y);
                if (dist > 128) {
                    object.x = x + lengthdir_x(128, dir);
                    object.y = y + lengthdir_y(128, dir);
                }
                if (global.run_virtual_ticks) with(object) motion_add(sign(x-other.x)*90+90, other.dist/100);
                
                if (ticks mod 10/global.delta_factor) {
                    ticks = 0;
                    if (object.object_index == Character) {
                        damageCharacter(ownerPlayer, object.id, 4);
                        if (object.lastDamageDealer != ownerPlayer and object.lastDamageDealer != object.player)
                        {
                            object.secondToLastDamageDealer = object.lastDamageDealer;
                            object.alarm[4] = object.alarm[3]
                        }
                        object.alarm[3] = ASSIST_TIME;
                        object.lastDamageDealer = ownerPlayer;
                        object.lastDamageSource = 255;
                    } else {
                        damageSentry(ownerPlayer, object.id, 4);
                    }   
                }
            }
        }
    } else {
        if (hspeed < 0.3) hspeed = 0;
        wallSetSolid();
        if (place_free(x, y)) {
            if(place_free(x+hspeed, y+vspeed+0.6)) vspeed += 0.6  * global.delta_factor;
            else if (global.run_virtual_ticks) hspeed *= 0.8;
            if(!place_free(x+hspeed, y+vspeed))
                event_user(2);
        } else {
            vspeed = 0;
            hspeed = 0;
        }
        
        if(vspeed > 10)
            vspeed = 10;
        
        wallUnsetSolid();
        
        x += hspeed * global.delta_factor;
        y += vspeed * global.delta_factor;
        x -= hspeed;
        y -= vspeed;
    }
');

object_event_add(GNsniperBomb, ev_other, ev_user2, '
    really_move_contact_solid(direction, speed);
    if(!place_free(x, y+1))
        vspeed = 0;
');

object_event_add(GNsniperBomb, ev_draw, 0, '
    draw_sprite_ext(GNanchorS, floor(animIndex) + ownerPlayer.team*5, x, y, 1, 1, 0, c_white, 1);
    draw_set_alpha(0.3);
    for(i=ds_list_size(locked)-1; i>=0; i-=1) {
        object = ds_list_find_value(locked, i);
        if (!instance_exists(object)) continue;
        if (ownerPlayer.team == TEAM_RED) color = c_red;
        else color = c_blue;
        draw_line_width_color(x , y, object.x, object.y, 3, color, color);
    }
');